"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.CollectorInterceptor = void 0;
const core_1 = require("@discord-nestjs/core");
const common_1 = require("@nestjs/common");
let CollectorInterceptor = class CollectorInterceptor {
    collectorProvider;
    constructor(collectorProvider) {
        this.collectorProvider = collectorProvider;
    }
    async intercept(context, next) {
        const classType = context.getClass();
        const methodName = context.getHandler().name;
        const eventArgs = context.getArgs();
        const eventContext = context.getArgByIndex(context.getArgs().length - 1);
        eventContext.collectors = await this.collectorProvider.applyCollector({
            classType,
            methodName,
            event: eventContext.event,
            eventArgs,
        });
        return next.handle();
    }
};
exports.CollectorInterceptor = CollectorInterceptor;
exports.CollectorInterceptor = CollectorInterceptor = __decorate([
    (0, common_1.Injectable)(),
    __metadata("design:paramtypes", [core_1.CollectorProvider])
], CollectorInterceptor);
//# sourceMappingURL=collector.interceptor.js.map