"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
var __param = (this && this.__param) || function (paramIndex, decorator) {
    return function (target, key) { decorator(target, key, paramIndex); }
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.ModalFieldsTransformPipe = void 0;
const core_1 = require("@discord-nestjs/core");
const common_1 = require("@nestjs/common");
const class_transformer_1 = require("class-transformer");
const transformer_options_constant_1 = require("../../contants/transformer-options.constant");
let ModalFieldsTransformPipe = class ModalFieldsTransformPipe {
    metadataProvider;
    classTransformerOptions;
    constructor(metadataProvider, classTransformerOptions) {
        this.metadataProvider = metadataProvider;
        this.classTransformerOptions = classTransformerOptions;
    }
    transform(interaction, metadata) {
        const { metatype } = metadata;
        if (!metatype ||
            !this.metadataProvider.isDto(metatype) ||
            !interaction ||
            typeof interaction['isModalSubmit'] !== 'function' ||
            !interaction.isModalSubmit())
            return;
        const dtoInstance = new metatype();
        const keys = Object.keys(dtoInstance);
        const plainObject = {};
        keys.forEach((property) => {
            const fieldCustomMetadata = this.metadataProvider.getFiledDecoratorMetadata(metatype, property);
            if (fieldCustomMetadata && interaction.fields) {
                plainObject[property] = interaction.fields.getField(fieldCustomMetadata.customId ?? property, fieldCustomMetadata.type);
                return;
            }
            const textInputValueCustomMetadata = this.metadataProvider.getTextInputValueDecoratorMetadata(metatype, property);
            if (textInputValueCustomMetadata && interaction.fields) {
                plainObject[property] = interaction.fields.getTextInputValue(textInputValueCustomMetadata.customId ?? property);
                return;
            }
        });
        return (0, class_transformer_1.plainToInstance)(metatype, plainObject, this.classTransformerOptions);
    }
};
exports.ModalFieldsTransformPipe = ModalFieldsTransformPipe;
exports.ModalFieldsTransformPipe = ModalFieldsTransformPipe = __decorate([
    (0, common_1.Injectable)(),
    __param(1, (0, common_1.Optional)()),
    __param(1, (0, common_1.Inject)(transformer_options_constant_1.TRANSFORMER_OPTION)),
    __metadata("design:paramtypes", [core_1.ReflectMetadataProvider, Object])
], ModalFieldsTransformPipe);
//# sourceMappingURL=modal-fields-transform.pipe.js.map