"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
var __param = (this && this.__param) || function (paramIndex, decorator) {
    return function (target, key) { decorator(target, key, paramIndex); }
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.SlashCommandPipe = void 0;
const core_1 = require("@discord-nestjs/core");
const common_1 = require("@nestjs/common");
const class_transformer_1 = require("class-transformer");
const discord_js_1 = require("discord.js");
const transformer_options_constant_1 = require("../../contants/transformer-options.constant");
/**
 * Fills DTO with values from interaction
 */
let SlashCommandPipe = class SlashCommandPipe {
    metadataProvider;
    classTransformerOptions;
    constructor(metadataProvider, classTransformerOptions) {
        this.metadataProvider = metadataProvider;
        this.classTransformerOptions = classTransformerOptions;
    }
    transform(interaction, metadata) {
        if (!metadata.metatype ||
            !this.metadataProvider.isDto(metadata.metatype) ||
            !interaction ||
            typeof interaction['isChatInputCommand'] !== 'function' ||
            !interaction.isChatInputCommand())
            return interaction;
        const plainObject = {};
        const dtoInstance = new metadata.metatype();
        const allKeys = Object.keys(dtoInstance);
        const assignWithoutTransform = {};
        allKeys.forEach((property) => {
            const paramDecoratorMetadata = this.metadataProvider.getParamDecoratorMetadata(metadata.metatype, property);
            if (!paramDecoratorMetadata)
                return;
            const { required, type } = paramDecoratorMetadata;
            const name = paramDecoratorMetadata.name ?? property;
            const interactionOption = interaction.options.get(name, required);
            plainObject[property] = interactionOption?.value ?? dtoInstance[property];
            if (type === core_1.ParamType.ATTACHMENT) {
                const propertyType = Reflect.getMetadata('design:type', dtoInstance, property);
                if (Object.is(propertyType, discord_js_1.Attachment)) {
                    assignWithoutTransform[property] =
                        interactionOption?.attachment ?? dtoInstance[property];
                }
            }
        });
        // class-validator breaks classes trying to recreate an instance from a property type
        const resultDto = (0, class_transformer_1.plainToInstance)(metadata.metatype, plainObject, this.classTransformerOptions);
        return Object.assign(resultDto, assignWithoutTransform);
    }
};
exports.SlashCommandPipe = SlashCommandPipe;
exports.SlashCommandPipe = SlashCommandPipe = __decorate([
    (0, common_1.Injectable)(),
    __param(1, (0, common_1.Optional)()),
    __param(1, (0, common_1.Inject)(transformer_options_constant_1.TRANSFORMER_OPTION)),
    __metadata("design:paramtypes", [core_1.ReflectMetadataProvider, Object])
], SlashCommandPipe);
//# sourceMappingURL=slash-command.pipe.js.map